import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Scanner;
import java.util.Collections;

public class Interact {
    private final static int MAX_TURNS = 40000;

    public static int calcDifferent(int[] a) {
        ArrayList<Integer> al = new ArrayList<>();
        int n = a.length;
        for (int i = 0; i < a.length; i++) {
            al.add(a[i]);
        }
        Collections.sort(al);
        int i = 0;
        int ans = 0;
        while (i < n) {
            ans++;
            while (i + 1 < n && al.get(i).equals(al.get(i + 1))) {
                i++;
            }
            i++;
        } 
        return ans;
    }
    
    public static void main(String[] args) throws FileNotFoundException {
        Scanner in = new Scanner(new File("different.in"));
        Scanner part = new Scanner(System.in);
        PrintWriter out = new PrintWriter(System.out);

        int n = in.nextInt();
        int[] a = new int[n];
        for (int i = 0; i < n; i++) {
            a[i] = in.nextInt();
        }
        int jAns = calcDifferent(a);
        out.println(n);
        out.flush();
        int turns = 0;
        
        while (true) {
            if (++turns > MAX_TURNS) {
                WA("Too many turns");
                return;
            }
        
            int type;
            try {
                type = part.nextInt();
            } catch (Throwable e) {
                PE("Wrong type of query - not int");
                return;
            }
            if (type <= 0 || type > 2) {
                PE("Wrong type: " + type);
                return;
            }
            if (type == 2) {
                int ans;
                try {
                    ans = part.nextInt();
                } catch (Throwable e) {
                    PE("Wrong answer - not int");
                    return;
                }
                if (ans != jAns) {
                    WA(String.format("Expected %d, found %d", jAns, ans));
                    return;
                }
                OK(turns);
                return;
            }
            int pi, pj;
            try {
                pi = part.nextInt() - 1;
                pj = part.nextInt() - 1;
            } catch (Throwable e) {
                PE("Wrong numbers in query - not int");
                return;
            }
            if (pi < 0 || pi >= n || pj < 0 || pj >= n) {
                PE(String.format("Wrong indexes: %d, %d", pi, pj));
                return;
            }
            if (a[pi] == a[pj]) {
                out.println("0");
                out.flush();
            } else if (a[pi] < a[pj]) {
                out.println("-1");
                out.flush();
            } else {
                out.println("1");
                out.flush();
            }
        }
    }

    private static void OK(int cnt) throws FileNotFoundException {
        PrintWriter pw = new PrintWriter("different.out");
        pw.print("OK ");
        pw.println("Contestant found the way after " + cnt + " moves");
        pw.close();
    }

    private static void PE(String s) throws FileNotFoundException {
        PrintWriter pw = new PrintWriter("different.out");
        pw.print("PE ");
        pw.println(s);
        pw.close();
    }

    private static void WA(String string) throws FileNotFoundException {
        PrintWriter pw = new PrintWriter("different.out");
        pw.print("WA ");
        pw.println(string);
        pw.close();
    }
}
