import java.io.*;
import java.util.Arrays;
import java.util.StringTokenizer;

public class districts_ip {
    FastScanner in;
    PrintWriter out;
    final String TASK_NAME = "districts";
    boolean[] can;

    boolean isBit(int ms, int i) {
        return ((ms>>i)&1) == 1;
    }

    public void solve() throws IOException {
        int n = in.nextInt(), m = in.nextInt();
        int tot = 1<<n;
        can = new boolean[tot];
        boolean[][][] diff = new boolean[n][n][n];

        for (int i = 0; i < m; ++i) {
            int x = in.nextInt();
            int y = in.nextInt();
            int z = in.nextInt();
            --x; --y; --z;
            int[] ar = new int[]{x, y, z};
            Arrays.sort(ar);
            diff[ar[0]][ar[1]][ar[2]] = true;
        }
        for (int ms = 0; ms < tot; ++ms) {
            boolean fail = false;
            for (int i = 0; i < n && !fail; ++i)
                if (isBit(ms, i))
                    for (int j = i + 1; j < n && !fail; ++j)
                        if (isBit(ms, j))
                            for (int k = j + 1; k < n && !fail; ++k)
                                fail = isBit(ms, k) && diff[i][j][k];
            can[ms] = !fail;
        }

        int[] dp = new int[tot];
        int[] parent = new int[tot];
        dp[0] = 0;
        for (int ms = 1; ms < tot; ++ms) {
            dp[ms] = n + 1;
            for (int j = ms; j > 0; j = (j - 1) & ms)
                if (can[j]) {
                    int val = dp[ms ^ j] + 1;
                    if (val < dp[ms]) {
                        dp[ms] = val;
                        parent[ms] = j;
                    }
                }
        }
        out.println(dp[tot - 1]);
        int mask = tot - 1, k = 0;
        int[] districts = new int[n];
        while (mask > 0) {
            ++k;
            for (int i = 0; i < n; ++i)
                if (isBit(parent[mask], i)) districts[i] = k;
            mask ^= parent[mask];
        }
        for (int i = 0; i < n; ++i)
            if (i + 1 == n)
                out.println(districts[i]);
            else
                out.print(districts[i] + " ");
    }

    public void run() {
        try {
            in = new FastScanner(new File(TASK_NAME + ".in"));
            out = new PrintWriter(new File(TASK_NAME + ".out"));

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    class FastScanner {
        BufferedReader br;
        StringTokenizer st;

        FastScanner(File f) {
            try {
                br = new BufferedReader(new FileReader(f));
            } catch (FileNotFoundException e) {
                e.printStackTrace();
            }
        }

        String next() {
            while (st == null || !st.hasMoreTokens()) {
                try {
                    st = new StringTokenizer(br.readLine());
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
            return st.nextToken();
        }

        int nextInt() {
            return Integer.parseInt(next());
        }
    }

    public static void main(String[] arg) {
        new districts_ip().run();
    }
}
