#include <cstdio>
#include <iostream>
#include <vector>
#include <algorithm>
#include <deque>
using namespace std;

int n, m, k;
vector<deque<string>> data;
vector<int> size;

int next(int ind)
{
    return (ind + 1) % n;
}

void insert(int ind, string c) 
{
    if ((int)c.size() == 0)
        return;
    data[ind].push_back(c);
    size[ind] += c.size();
    while (size[ind] - (int)data[ind].front().size() >= m + k)
    {
        size[ind] -= data[ind].front().size();
        data[ind].pop_front();
    }
}    

void erase(int ind) 
{
    if (size[ind] == 0)
        return;
    string s = data[ind].back();
    data[ind].pop_back();
    //cerr << s.size() << endl;
    s.resize(s.size() - 1);
    if ((int)s.size() > 0)
        data[ind].push_back(s);
    size[ind]--;  
}

string get_all(int ind)
{
    string tmp = "";
    while (!data[ind].empty()) 
    {
        tmp += data[ind].front();
        data[ind].pop_front();
    }
    if (tmp == "")
        return "";
    data[ind].push_back(tmp);
    if ((int)tmp.size() <= k)
        return tmp;
    return tmp.substr(tmp.size() - k, k);
}

int main() 
{
    freopen("notepad.in", "rt", stdin);
    freopen("notepad.out", "wt", stdout);
    cin >> n >> m >> k;
    data.assign(n, deque<string>());
    size.assign(n, 0);
    string buffer = "";
    int cur = 0;
    while (m-- > 0)
    {
        string s;
        cin >> s;
        if ((int)s.size() == 1)
            insert(cur, s);
        else if (s == "Backspace")
            erase(cur);
        else if (s == "Next")
            cur = next(cur);
        else if (s == "Copy")
            buffer = get_all(cur);  
        else if (s == "Paste")
            insert(cur, buffer);
        //cerr << m << endl;
        //cerr << get_all(cur) << endl;
    }
    string res = get_all(cur);
    if ((int)res.size() == 0) 
        cout << "Empty" << endl;
    else
        cout << res << endl;
    return 0;
}