#include <bits/stdc++.h>

const int maxn = 1e6 + 10;

static const int ms = 2;
static const long long mods[ms] = {(int)1e9 + 7, 999999937};
static const long long base = 239017;
long long powers[ms][maxn];
long long hashes[ms][maxn];

long long mmod(long long x, long long mod) {
    return (x % mod + mod) % mod;
}
    
long long get(int id, int l, int r) {
    return mmod(hashes[id][r + 1] - hashes[id][l] * powers[id][r - l + 1], mods[id]);
}

int n;
char s[maxn];

bool equals(int l1, int r1, int l2, int r2) {
    bool result = true;
    for (int i = 0; i < ms; i++) {
        result &= get(i, l1, r1) == get(i, l2, r2);
    }
    return result;
}

bool check_period(int period) {
    {
        int max_left = 1;
        while (max_left < (n - 1) / period && equals(1, period, max_left * period + 1, (max_left + 1) * period)) {
            max_left++;
        }
        if (max_left == (n - 1) / period) {
            if ((n - 1) % period == 0) {
                return true;
            }
            if (equals(1, (n - 1) % period, n - ((n - 1) % period), n - 1)) {
                return true;
            }
        }
    }
    int max_left = 1;
    while (max_left < n / period && equals(0, period - 1, max_left * period, (max_left + 1) * period - 1)) {
        max_left++;
    }
    if (max_left == n / period) {
        if (n % period == 0) {
            return true;
        }
        return equals(0, n % period - 1, n - (n % period), n - 1);
    }
    if (max_left * period + period + 1 > n) {
        int pos = max_left * period;
        int l = 1, r = n - pos;
        if (s[pos] != s[0]) {
            return equals(0, n - pos - 2, pos + 1, n - 1);
        }
        while (l < r - 1) {
            int m = (l + r) / 2;
            if (equals(0, m - 1, pos, pos + m - 1)) {
                l = m;
            } else {
                r = m;
            }
        }
        return l == period || equals(l, n - 2 - pos, pos + l + 1, n - 1);
    }
    int pos = (max_left + 1) * period + 1;
    while (pos + period <= n) {
        if (!equals(0, period - 1, pos, pos + period - 1)) {
            return false;
        }
        pos += period;
    }
    if (pos < n && !equals(0, n - pos - 1, pos, n - 1)) {
        return false;
    }
    pos = max_left * period;
    if (s[pos] != s[0]) {
        return equals(0, period - 1, pos + 1, pos + period);
    }
    int l = 1, r = period + 1;
    while (l < r - 1) {
        int m = (l + r) / 2;
        if (equals(0, m - 1, pos, pos + m - 1)) {
            l = m;
        } else {
            r = m;
        }
    }
    return l == period || equals(l, period - 1, pos + l + 1, (max_left + 1) * period);
}

int main() {
    freopen("periods.in", "r", stdin);
    freopen("periods.out", "w", stdout);
    scanf("%s", s);
    n = strlen(s);
    for (int it = 0; it < ms; it++) {
        powers[it][0] = 1;
        for (int i = 1; i < maxn; i++) {
            powers[it][i] = mmod(powers[it][i - 1] * base, mods[it]);
        }
        hashes[it][0] = 0;
        for (int i = 0; i < n; i++) {
            hashes[it][i + 1] = mmod(hashes[it][i] * base + s[i], mods[it]);
        }
    }

    for (int period = 1; period <= n; period++) {
        if (check_period(period)) {
            printf("%d\n", period);
            return 0;
        }
    }
    return 0;
}