import random
import os
import shutil
import math

if os.path.exists('../tests'):
    print('Directory "tests" already exists')
    shutil.rmtree('../tests', ignore_errors=False, onerror=None)

try:
    os.makedirs('../tests')
except OSError:
    pass


random.seed(239)

test_number = 1

def write_test(arr):
    global test_number
    name = "0" * (2 - len(str(test_number))) + str(test_number)

    outp = open("../tests/" + name, "w")

    outp.write(str(len(arr)) + "\n")
    for p in arr:
        outp.write(str(p[0]) + " " + str(p[1]) + "\n")

    print("Test #" + str(test_number) + " has been generated")
    test_number += 1
    outp.close()
    

write_test([[8, 5], [5, 1]])
max_test_size = 100

for i in range(10):
    arr = []
    for j in range(10):
        k = random.randint(1, 1000)
        n = random.randint(1, min(1000, k * 10))    
        arr.append([n, k])
    write_test(arr)

write_test([[10 ** 18, 10 ** 17]])
write_test([[10 ** 18 - 1, 10 ** 17]])

for i in range(10):
    arr = []
    for j in range(max_test_size):
        k = random.randint(1, 10 ** 17)
        n = random.randint(k * i, k * (i + 1))
        arr.append([n, k])
    write_test(arr)

for i in range(5):
    arr = []
    for j in range(max_test_size):
        k = random.randint(1, 10 ** 17)
        n = random.randint(1, k * 10)
        arr.append([n, k])
    write_test(arr)

arr = []
for i in range(10):
    for j in range(10):
        n = 10 ** 18 - i
        k = 10 ** 17 - j
        n = min(n, k * 10)
        arr.append([n, k])

write_test(arr)

arr = []
for i in range(10):
    for j in range(10):
        n = 10 ** 18 - i
        k = 10 ** 18 - j
        n = min(n, k * 10)
        arr.append([n, k])

write_test(arr)


arr = []
for i in range(10):
    for j in range(10):
        n = (10 ** 9 - 1) ** 2 - i
        k = 10 ** 17 - j
        n = min(n, k * 10)
        arr.append([n, k])

write_test(arr)
