import ru.ifmo.testlib.Checker;
import ru.ifmo.testlib.InStream;
import ru.ifmo.testlib.Outcome;
import static ru.ifmo.testlib.Outcome.Type.*;

import java.util.HashSet;
import java.util.Arrays;

public class Check implements Checker {
    public Outcome outcome(Outcome.Type type, final String format, final Object... args) {
        return new Outcome(type, String.format(format, args));
    }

    public Outcome test(InStream inf, InStream ouf, InStream ans) {
        int n = inf.nextInt();
        int m = inf.nextInt();
        int[] a = new int[n];
        int[] b = new int[n];
        for (int i = 0; i < n; i++) {
            a[i] = inf.nextInt();
            b[i] = inf.nextInt();
        }
        int jAns = ans.nextInt();
        int pAns = ouf.nextInt();
        if (pAns < jAns) {
            return outcome(WA, String.format("Expected sum: %d, found: %d", jAns, pAns));
        }
        int[] p = new int[n];
        int sum = 0;
        int up = 0;
        for (int i = 0; i < n; i++) {
            p[i] = ouf.nextInt();
            sum += p[i] == 0 ? a[i] : b[i];
            up += p[i] == 1 ? 1 : 0;
        }
        if (sum != pAns) {
            return outcome(WA, "Sum in certificate is not equal to first number in output");
        }
        if (Math.abs(up - (n - up)) > m) {
            return outcome(WA, "Wrong sertificate: absolute difference if more than M");
        }
        if (pAns > jAns) {
            return outcome(FAIL, String.format("Participant found better answer: expected %d, found %d", jAns, pAns));
        }
        return outcome(OK, "sum=" + jAns);
    }
}
